<?php
/**
 * @package		Content Tabs (& Sliders) for Joomla! 1.6
 * @type		Plugin (Content)
 * @filename	contenttabs.php
 * @folder		<root>/plugins/content/contenttabs
 * @version		2.0 
 * @modified	01 March 2011
 * @author		ToolJoom.com - Tools for Joomla!
 * @website		http://www.tooljoom.com
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * 
 * @copyright (C) 2011 ToolJoom.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
**/

defined('_JEXEC') or die('Restricted access');

class plgContentContentTabs extends JPlugin
{
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}
	
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		if ((JString::strpos($article->text, '{tabs') === false) || (JString::strpos($article->text, '{/tabs}') === false)) {
			return true;
		}
		
		$doc = &JFactory::getDocument();
		$doc->addStyleSheet('/plugins/content/contenttabs/css/contenttabs.css');
					
		$regex = "#{tabs type=\s*(.*?)}(.*?){/tabs}#s";
		
		$article->text = preg_replace_callback($regex, array(&$this, '_tabs'), $article->text);
		
		return true;
	}
		
	protected function _tabs($matches)
	{
		if ((JString::strpos($matches[2], '{tab') === false) || (JString::strpos($matches[2], '{/tab}') === false)) {
			return true;
		}
		
		$regex = "#(?<={/tab}).*?(?={tab)#s";
		
		$matches[2] = preg_replace_callback($regex, array(&$this, '_between'), $matches[2]);
				
		jimport('joomla.html.pane');
		$this->_pane = &JPane::getInstance($matches[1], array('startOffset' => 0));
		$tabs = '<div id="contentPaneWrapper">';
		$tabs .= $this->_pane->startPane('contentPane');
		
		$regex = "#{tab title=\s*(.*?)}(.*?){/tab}#s";
		
		$tabs .= preg_replace_callback($regex, array(&$this, '_tab'), $matches[2]);
		$tabs .= $this->_pane->endPane();
		$tabs .= '</div>';
		
		return $tabs;
	}
	
	protected function _between($matches)
	{
		$text = '';
		
		return $text;
	}
	
	protected function _tab($matches)
	{	
		$title = $matches[1];
		$text = $matches[2];
		$tab = $this->_pane->startPanel($title, 'contentPaneTab') . $text . $this->_pane->endPanel();
		
		return $tab;
	}
}